package com.gg.game;

import java.util.ArrayList;
import javax.microedition.khronos.opengles.GL10;
import android.view.MotionEvent;
import android.widget.Toast;
import com.gg.module.*;
import com.gg.top.BasicTop;
import com.gg.top.DrawTop;
import com.gg.util.*;
import com.gg.view.R;

/* Ϸģʽ࣬ͨάת÷ */
public class ClassicGame extends GameFrame implements Runnable { // ̳Ϸ࣬ʵϷʵֵĺ

	/* 3Dͼõı */
	private GL10 gl; // 3DҪgl
	private int coneTextureId; // ݵײԲ׶
	private int cylinderTextureId; // мԲ
	private int circleTextureId; // ݶԲ
	private int pauseTextureId; // ͣʱʾͼƬ

	/* ӦϢõı */
	private long startTime; // ʼӦϢʱ̣ʱ
	private long endTime; // startTimeӦ
	private long touchStart; // startTimeʼӦϢʱ̣ڿACTION_MOVEʱӦҪ̫
	private boolean responseFlag; // ʾӦϢı־
	private Point firstPoint; // ӦϢĵһ㣬лϢն߶
	private Point secondPoint; // ӦϢĵڶ

	/* Ϸ߼õı */
	private Thread thread; // Ϸ߼е߳
	private int state; // ʾϷ״̬ı
	private double duration; // ʾϷеʱ
	private double score; // ʾϷĿǰĵ÷֣ע÷ֱֲʱصģݵµĽǶйأݵĽǶԽ÷ҲԽߣ
	private DrawTop drawTop; // 3Dݶ
	private Circle logicCircle; // ݵ߼ԲʵϻײӦ߼ԲģӶ
	private DrawBackground drawPause; // ͣı

	/* 罻ı */
	private boolean collideFlag; // ʾݣʵ߼ԲԵҪⲿActivityʹֻ
	private boolean crackFlag; // ٺ٣ʾCrackܵı־

	/* Ƚرı */
	private boolean difficultyFlag; // ʾѶӵı־ڹ̶ʱϷѶ
	
	public ClassicGame(GL10 gl, int coneTextureId, int cylinderTextureId,
			int circleTextureId, int pauseTextureId) { // ʼ3DԴ

		this.gl = gl;
		this.coneTextureId = coneTextureId;
		this.cylinderTextureId = cylinderTextureId;
		this.circleTextureId = circleTextureId;
		this.pauseTextureId = pauseTextureId;

		state = PREPARE; // ϷΪ׼״̬
		init(); // ʼϷĶԴעʱûʼϷ
	}

	@Override
	public void init() {
		// TODO Auto-generated method stub
		
		drawTop = new DrawTop(coneTextureId, cylinderTextureId, circleTextureId);// ݶ󣬲Ӧͼ
		logicCircle = new Circle(drawTop.getBasicPoint().x, 
				drawTop.getBasicPoint().y, drawTop.getRadius()); // Ϊ߼Բ

		drawPause = new DrawBackground(pauseTextureId); // 󣬲Ӧͼ

		firstPoint = new Point(0f, 0f, 0f); // صĶ󣨾ͺҵԭˣ
		secondPoint = new Point(0f, 0f, 0f); // ͬصĶ
	}

	@Override
	public void start() {
		// TODO Auto-generated method stub
		
		state = RUN; // Ϸ״̬ĳRUN״̬
		drawTop.setState(RUN); // ״̬ĳRUN״̬

		duration = 0; // ϷʱΪ
		score = 0; // ϷΪ

		thread = new Thread(this); // Ϸ߼е̶߳
		thread.start(); // 㿪Ϸ߼߳
	}

	public void run() {
		// TODO Auto-generated method stub
		
		while (true) { // ѭ֤ϷʲôϷ״̬¶ܰҪУҵô˺ʱǹ̶
			long start = System.currentTimeMillis(); // ȼ¼һСѭĿʼʱ

			logic(); // Ϸ߼

			long end = System.currentTimeMillis(); // ¼һСѭĽʱ

			try {
				if (end - start < Constant.INTERVAL) { // ߼еʱȹ涨ʱ
					thread.sleep(Constant.INTERVAL - (end - start)); // ǵĲֵӶ֤ÿ涨ʱһСѭ
				}
			} catch (Exception e) { // ΪsleepҪ쳣
				e.printStackTrace();
			}
		}
	}

	@Override
	public void onTouch(MotionEvent e) {
		// TODO Auto-generated method stub
		
		switch (e.getAction()) {
		case MotionEvent.ACTION_DOWN:
			if (state == RUN) {
				responseFlag = false;
			} else if (state == PAUSE) {
				double x = Constant.convertX(e.getX());
				double y = Constant.convertY(e.getY());
				
				if(x>-0.8 && x<-0.2 && y>0.-6 && y<0.0){
					resume();
				}else if(x<0.8 && x>0.2 && y>0.-6 && y<0.0){
					end();
				}
			}
			break;
		case MotionEvent.ACTION_MOVE:
			if (state == RUN) {
				if (responseFlag == false) {
					if (isInLogicCircle(Constant.convertX(e.getX()),
							Constant.convertY(e.getY()))) {
						startTime = System.currentTimeMillis();

						touchStart = System.currentTimeMillis();

						firstPoint.x = Constant.convertX(e.getX());
						firstPoint.y = Constant.convertY(e.getY());

						responseFlag = true;
					}
				} else {
					endTime = System.currentTimeMillis();

					if (crackFlag == true) {
						endTime = 0;
					}

					if (endTime - startTime > 90) {
						return;
					}

					if (System.currentTimeMillis() - touchStart > Constant.INTERVAL) {
						if (isInLogicCircle(Constant.convertX(e.getX()),
								Constant.convertY(e.getY()))) {
							secondPoint.x = Constant.convertX(e.getX());
							secondPoint.y = Constant.convertY(e.getY());

							responseTouch(firstPoint, secondPoint);
							// System.out.println("response");

							touchStart = System.currentTimeMillis();
							firstPoint.x = Constant.convertX(e.getX());
							firstPoint.y = Constant.convertY(e.getY());
						}

					}
				}
			}

			break;
		case MotionEvent.ACTION_UP:
			if (state == RUN) {
				firstPoint.x = 0;
				firstPoint.y = 0;
				secondPoint.x = 0;
				secondPoint.y = 0;

				responseFlag = false;
			}

			break;
		}
	}

	@Override
	public void logic() {
		// TODO Auto-generated method stub

		if (state == RUN) {
			drawTop.logic();

			updateLogicCircle();

			duration += (double) Constant.INTERVAL / 1000;
			score += (double) Constant.INTERVAL / 1000 * drawTop.getAxleAngle()
					* 10 + duration * 120 / 1000;// ֮һɼʱ乱׵

			if ((int) duration % 30 == 29) {
				difficultyFlag = true;
				drawTop.setAutoAngleAccelerate(drawTop.getAutoAngleAccelerate() * 1.005f);
			}

		} else if (state == PAUSE) {

		}

		if (drawTop.getAxleAngle() > drawTop.getDEAD_AXLE_ANGLE()) {
			end();
		}

		if (logicCircle.getCenter().x - logicCircle.getRadius() <= -Constant.LOGIC_WIDTH / 2) { // ײǽ
			drawTop.getBasicPoint().x += 0.1f; // ҪƽƷֹٴײ0.05Ļײ껹ײ0.1Ͳˣ
			drawTop.setxMoveSpeed(-drawTop.getxMoveSpeed() * 1 / 2); // ٶȷ򲢼
			drawTop.setAngleSpeed(drawTop.getAngleSpeed() * 9 / 10); // ٶȼ
			collideFlag = true; // ײ־ԷϢӦ
		} else if (logicCircle.getCenter().x + logicCircle.getRadius() >= Constant.LOGIC_WIDTH / 2) { // ײǽ
			drawTop.getBasicPoint().x -= 0.1f;
			drawTop.setxMoveSpeed(-drawTop.getxMoveSpeed() * 1 / 2);
			drawTop.setAngleSpeed(drawTop.getAngleSpeed() * 9 / 10);
			collideFlag = true;
		}

		if (logicCircle.getCenter().y + logicCircle.getRadius() >= Constant.LOGIC_HEIGHT / 2) { // ײǽ
			drawTop.getBasicPoint().y -= 0.1f;
			drawTop.setyMoveSpeed(-drawTop.getyMoveSpeed() * 1 / 2);
			drawTop.setAngleSpeed(drawTop.getAngleSpeed() * 9 / 10);
			collideFlag = true;
		} else if (logicCircle.getCenter().y - logicCircle.getRadius() <= -Constant.LOGIC_HEIGHT / 2) { // ײǽ
			drawTop.getBasicPoint().y += 0.1f;
			drawTop.setyMoveSpeed(-drawTop.getyMoveSpeed() * 1 / 2);
			drawTop.setAngleSpeed(drawTop.getAngleSpeed() * 9 / 10);
			collideFlag = true;
		}

	}

	@Override
	public void draw(GL10 gl) {
		// TODO Auto-generated method stub
		if (state == RUN) {
			drawTop.drawSelf(gl);
		} else if (state == PAUSE) {
			drawPause.drawSelf(gl);
		}
	}

	@Override
	public void pause() {
		// TODO Auto-generated method stub

		state = PAUSE;
	}

	@Override
	public void resume() {
		// TODO Auto-generated method stub

		state = RUN;
	}

	@Override
	public void end() {
		// TODO Auto-generated method stub

		try {
			Thread.sleep(500);
		} catch (Exception e) {
			e.printStackTrace();
		}

		state = END;
		drawTop.setState(END);

	}

	@Override
	public void save() {
		// TODO Auto-generated method stub

	}

	@Override
	public void load() {
		// TODO Auto-generated method stub

	}

	public DrawTop getDrawTop() {
		return drawTop;
	}

	public int getState() {
		return state;
	}

	public void setState(int state) {
		this.state = state;
	}

	public void updateLogicCircle() {
		logicCircle.getCenter().x = drawTop.getBasicPoint().x + 3
				* drawTop.getRadius()
				* (float) Math.sin(drawTop.getAxleAngle() * Math.PI / 180)
				* (float) Math.cos(drawTop.getAxleAngleCount() * Math.PI / 180);
		logicCircle.getCenter().y = drawTop.getBasicPoint().y + 3
				* drawTop.getRadius()
				* (float) Math.sin(drawTop.getAxleAngle() * Math.PI / 180)
				* (float) Math.sin(drawTop.getAxleAngleCount() * Math.PI / 180);
		logicCircle.setRadius(drawTop.getRadius());

	}

	public boolean isInLogicCircle(float x, float y) {
		float distance = (float) Math.sqrt((x - logicCircle.getCenter().x)
				* (x - logicCircle.getCenter().x)
				+ (y - logicCircle.getCenter().y)
				* (y - logicCircle.getCenter().y));
		if (distance < logicCircle.getRadius() * 1.2
				&& distance > logicCircle.getRadius() / 3) {
			return true;
		} else {
			return false;
		}

	}

	public void responseTouch(Point firstPoint, Point secondPoint) {

		Line touchLine = new Line(firstPoint, secondPoint);
		Line axleLine = new Line(drawTop.getBasicPoint(),
				logicCircle.getCenter());

		float angleSpeedOffset = 0.7f; // ת޴һӵĽٶȣ1.0Ϳ˲٣0.8ף0.5ά,0.6Ҳͦ,0.7ͦõģ
		float downAngleSpeedOffset = 0.5f; // ĵĽٶȣ߻ĿԺ

		float xMoveOffset = 0.04f; // Ĵһx᷽ĵ루0.06е,0.04ܵס˶ҲԾ
		float yMoveOffset = 0.04f; // Ĵһy᷽ĵ
		float xMoveSpeedOffset = 0.0015f; // Ĵһx᷽ٶȵĸı0.001ˣξЧ,0.02ѿƣ0.0015ˣ
		float yMoveSpeedOffset = 0.0015f; // Ĵһy᷽ٶȵĸı

		switch (touchLine.getDirection().getDirection()) { // жֻߵķ
		case Direction.UP_RIGHT: // Ϸ
			if (touchLine.directionCircle(logicCircle).getDirection() == Direction.DOWN) { // ж߼Բ·
				angleSpeedOffset = -angleSpeedOffset; // ٶȼ
				xMoveSpeedOffset = -xMoveSpeedOffset; // һ
				yMoveSpeedOffset = yMoveSpeedOffset; // һ
				xMoveOffset = -xMoveOffset; // ٶȼٻٶ
				yMoveOffset = yMoveOffset; // ٶӻٶȼ
				if (axleLine.getDirection().getDirection() == Direction.UP_LEFT) { // Ϸ
					downAngleSpeedOffset = -downAngleSpeedOffset; // ĵٶȼ٣
				} else if (axleLine.getDirection().getDirection() == Direction.DOWN_RIGHT) { // Ϸ
					downAngleSpeedOffset = downAngleSpeedOffset; // ٶӣ
				}
			} else if (touchLine.directionCircle(logicCircle).getDirection() == Direction.UP) {
				angleSpeedOffset = angleSpeedOffset;
				xMoveSpeedOffset = xMoveSpeedOffset;
				yMoveSpeedOffset = -yMoveSpeedOffset;
				xMoveOffset = xMoveOffset;
				yMoveOffset = -yMoveOffset;
				if (axleLine.getDirection().getDirection() == Direction.DOWN_RIGHT) {
					downAngleSpeedOffset = -downAngleSpeedOffset;
				} else if (axleLine.getDirection().getDirection() == Direction.UP_LEFT) {
					downAngleSpeedOffset = downAngleSpeedOffset;
				}
			}
			break;
		case Direction.DOWN_RIGHT:
			if (touchLine.directionCircle(logicCircle).getDirection() == Direction.DOWN) {
				angleSpeedOffset = -angleSpeedOffset;
				xMoveSpeedOffset = xMoveSpeedOffset;
				yMoveSpeedOffset = yMoveSpeedOffset;
				xMoveOffset = xMoveOffset;
				yMoveOffset = yMoveOffset;
				if (axleLine.getDirection().getDirection() == Direction.UP_RIGHT) {
					downAngleSpeedOffset = -downAngleSpeedOffset;
				} else if (axleLine.getDirection().getDirection() == Direction.DOWN_LEFT) {
					downAngleSpeedOffset = downAngleSpeedOffset;
				}
			} else if (touchLine.directionCircle(logicCircle).getDirection() == Direction.UP) {
				angleSpeedOffset = angleSpeedOffset;
				xMoveSpeedOffset = -xMoveSpeedOffset;
				yMoveSpeedOffset = -yMoveSpeedOffset;
				xMoveOffset = -xMoveOffset;
				yMoveOffset = -yMoveOffset;
				if (axleLine.getDirection().getDirection() == Direction.DOWN_LEFT) {
					downAngleSpeedOffset = -downAngleSpeedOffset;
				} else if (axleLine.getDirection().getDirection() == Direction.UP_RIGHT) {
					downAngleSpeedOffset = downAngleSpeedOffset;
				}
			}
			break;
		case Direction.UP_LEFT:
			if (touchLine.directionCircle(logicCircle).getDirection() == Direction.DOWN) {
				angleSpeedOffset = angleSpeedOffset;
				xMoveSpeedOffset = xMoveSpeedOffset;
				yMoveSpeedOffset = yMoveSpeedOffset;
				xMoveOffset = xMoveOffset;
				yMoveOffset = yMoveOffset;
				if (axleLine.getDirection().getDirection() == Direction.UP_RIGHT) {
					downAngleSpeedOffset = -downAngleSpeedOffset;
				} else if (axleLine.getDirection().getDirection() == Direction.DOWN_LEFT) {
					downAngleSpeedOffset = downAngleSpeedOffset;
				}
			} else if (touchLine.directionCircle(logicCircle).getDirection() == Direction.UP) {
				angleSpeedOffset = -angleSpeedOffset;
				xMoveSpeedOffset = -xMoveSpeedOffset;
				yMoveSpeedOffset = -yMoveSpeedOffset;
				xMoveOffset = -xMoveOffset;
				yMoveOffset = -yMoveOffset;
				if (axleLine.getDirection().getDirection() == Direction.DOWN_LEFT) {
					downAngleSpeedOffset = -downAngleSpeedOffset;
				} else if (axleLine.getDirection().getDirection() == Direction.UP_RIGHT) {
					downAngleSpeedOffset = downAngleSpeedOffset;
				}
			}
			break;
		case Direction.DOWN_LEFT:
			if (touchLine.directionCircle(logicCircle).getDirection() == Direction.DOWN) {
				angleSpeedOffset = angleSpeedOffset;
				xMoveSpeedOffset = -xMoveSpeedOffset;
				yMoveSpeedOffset = yMoveSpeedOffset;
				xMoveOffset = -xMoveOffset;
				yMoveOffset = yMoveOffset;
				if (axleLine.getDirection().getDirection() == Direction.UP_LEFT) {
					downAngleSpeedOffset = -downAngleSpeedOffset;
				} else if (axleLine.getDirection().getDirection() == Direction.DOWN_RIGHT) {
					downAngleSpeedOffset = downAngleSpeedOffset;
				}
			} else if (touchLine.directionCircle(logicCircle).getDirection() == Direction.UP) {
				angleSpeedOffset = -angleSpeedOffset;
				xMoveSpeedOffset = xMoveSpeedOffset;
				yMoveSpeedOffset = -yMoveSpeedOffset;
				xMoveOffset = xMoveOffset;
				yMoveOffset = -yMoveOffset;
				if (axleLine.getDirection().getDirection() == Direction.DOWN_RIGHT) {
					downAngleSpeedOffset = -downAngleSpeedOffset;
				} else if (axleLine.getDirection().getDirection() == Direction.UP_LEFT) {
					downAngleSpeedOffset = downAngleSpeedOffset;
				}
			}
			break;
		}

		if (drawTop.getAngleSpeed() + angleSpeedOffset < BasicTop.MAX_ANGLE_SPEED) { // ǰƫ
			drawTop.setAngleSpeed(drawTop.getAngleSpeed() + angleSpeedOffset);
		}

		if (drawTop.getAngleSpeed() + downAngleSpeedOffset < BasicTop.MAX_ANGLE_SPEED) {
			drawTop.setAngleSpeed(drawTop.getAngleSpeed()
					+ downAngleSpeedOffset);
		}

		if (Math.abs(drawTop.getxMoveSpeed() + xMoveSpeedOffset) < BasicTop.X_MAX_MOVE_SPEED) {
			drawTop.setxMoveSpeed(drawTop.getxMoveSpeed() + xMoveSpeedOffset);
		}

		if (Math.abs(drawTop.getyMoveSpeed() + yMoveSpeedOffset) < BasicTop.Y_MAX_MOVE_SPEED) {
			drawTop.setyMoveSpeed(drawTop.getyMoveSpeed() + yMoveSpeedOffset);
		}

		if (drawTop.getBasicPoint().x + xMoveOffset > -Constant.LOGIC_WIDTH / 2
				&& drawTop.getBasicPoint().x + xMoveOffset < Constant.LOGIC_WIDTH / 2) {
			drawTop.setBasicPoint(new Point(drawTop.getBasicPoint().x
					+ xMoveOffset, drawTop.getBasicPoint().y));
		}

		if (drawTop.getBasicPoint().y + yMoveOffset > -Constant.LOGIC_HEIGHT / 2
				&& drawTop.getBasicPoint().y + yMoveOffset < Constant.LOGIC_HEIGHT / 2) {
			drawTop.setBasicPoint(new Point(drawTop.getBasicPoint().x, drawTop
					.getBasicPoint().y + yMoveOffset));
		}

	}

	public double getDuration() {
		return duration;
	}

	public void setDuration(double duration) {
		this.duration = duration;
	}

	public double getScore() {
		return score;
	}

	public void setScore(double score) {
		this.score = score;
	}

	public boolean isCollideFlag() {
		return collideFlag;
	}

	public void setCollideFlag(boolean collideFlag) {
		this.collideFlag = collideFlag;
	}

	public boolean isDifficultyFlag() {
		return difficultyFlag;
	}

	public void setDifficultyFlag(boolean difficultFlag) {
		this.difficultyFlag = difficultFlag;
	}

	public boolean isCrackFlag() {
		return crackFlag;
	}

	public void setCrackFlag(boolean crackFlag) {
		this.crackFlag = crackFlag;
	}

}
